'use strict';

exports.__esModule = true;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _lodash = require('lodash');

var _assignable = require('../utils/assignable');

var _assignable2 = _interopRequireDefault(_assignable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------
var BrowserConsoleMessages = function (_Assignable) {
    (0, _inherits3.default)(BrowserConsoleMessages, _Assignable);

    function BrowserConsoleMessages(obj) {
        (0, _classCallCheck3.default)(this, BrowserConsoleMessages);

        var _this = (0, _possibleConstructorReturn3.default)(this, _Assignable.call(this));

        _this.log = [];
        _this.info = [];
        _this.warn = [];
        _this.error = [];

        _this._assignFrom(obj);
        return _this;
    }

    BrowserConsoleMessages.prototype._getAssignableProperties = function _getAssignableProperties() {
        return [{ name: 'log' }, { name: 'info' }, { name: 'warn' }, { name: 'error' }];
    };

    BrowserConsoleMessages.prototype.concat = function concat(consoleMessages) {
        this.log = this.log.concat(consoleMessages.log);
        this.info = this.info.concat(consoleMessages.info);
        this.warn = this.warn.concat(consoleMessages.warn);
        this.error = this.error.concat(consoleMessages.error);
    };

    BrowserConsoleMessages.prototype.addMessage = function addMessage(type, msg) {
        this[type].push(msg);
    };

    BrowserConsoleMessages.prototype.getCopy = function getCopy() {
        var log = this.log,
            info = this.info,
            warn = this.warn,
            error = this.error;


        return (0, _lodash.assignIn)({}, { log: log, info: info, warn: warn, error: error });
    };

    return BrowserConsoleMessages;
}(_assignable2.default);

exports.default = BrowserConsoleMessages;
module.exports = exports['default'];